Lattice Grid Buy a licence

demo D296

Ten million transactions in Parquet in Angular

Ten million card transactions queried by DuckDB in the tab: every filter, sort and page becomes one statement, and only the hundred rows on screen come back

duckdbAdapter · createPushdownSource

Ten million card transactions sit in a Parquet file that never enters the grid. Every filter, sort and scroll becomes one statement DuckDB answers, and only the hundred rows on screen come back, with the statement, its bound values and its measured time printed beside them.

Building…
Loading a live grid…

This is the Angular version. A standalone component takes the whole configuration through one config input, surfaces grid events as outputs, and exposes the live grid on a getter for anything the inputs do not cover.

The configuration

import { Component, ViewChild, signal } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid, duckdbAdapter, createPushdownSource } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import * as LatticeGridCore from '@toclocoinc/lattice-grid';
// DuckDB is your engine, not ours: the grid imports none of it. Swap this
// import for a connection to your own warehouse and nothing below changes.
import * as duckdb from 'https://cdn.jsdelivr.net/npm/@duckdb/duckdb-wasm/+esm';
import { LatticeGridComponent, provideLattice } from '@toclocoinc/lattice-grid/angular';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '@if (config(); as c) { <lattice-grid [config]="c" (gridReady)="onGridReady($event)" style="display:block;height:620px"></lattice-grid> }',
})
export class AppComponent {
  config = signal<any>(null);

  constructor() {
    (async () => {
      const bundle = await duckdb.selectBundle(duckdb.getJsDelivrBundles());
      const worker = await duckdb.createWorker(bundle.mainWorker);
      const db = new duckdb.AsyncDuckDB(new duckdb.ConsoleLogger(), worker);
      await db.instantiate(bundle.mainModule, bundle.pthreadWorker);
      const connection = await db.connect();

      // The engine resolves the URL, so give it an absolute one.
      const file = new URL('/demo-data/transactions-10m.parquet', location.origin).href;
      const adapter = duckdbAdapter({ connection, from: `read_parquet('${file}')` });

      // Windowed: the source turns the grid's filter, sort and scroll
      // position into one statement, and only the page on screen comes back.
      const source = createPushdownSource({
        adapter, compute: LatticeGridCore, pageSize: 100,
        aggregates: { default: 'engine-if-identical' },
      });

      this.config.set({
        rowKey: 'transaction_id',
        toolPanel: { side: 'left', panels: ['filters', 'columns'] },
        columns: [
          { field: 'ts', title: 'Time (UTC)', type: 'timestamp', typeOptions: { timeZone: 'UTC' } },
          { field: 'merchant', title: 'Merchant', filter: { type: 'set' } },
          { field: 'category', title: 'Category', filter: { type: 'set' } },
          { field: 'country', title: 'Country', filter: { type: 'set' } },
          { field: 'amount', title: 'Amount', type: 'number', format: { style: 'currency', currency: 'GBP' } },
          { field: 'status', title: 'Status', filter: { type: 'set' } },
          { field: 'risk_score', title: 'Risk', type: 'number' },
        ],
        source,
      });
    })();
  }

  onGridReady(grid: any) {
    // Any filter is an ordinary filter tree, and the adapter binds every
    // value rather than pasting it into the statement.
    grid.filters.set({ op: 'and', conditions: [
      { col: 'country', op: 'eq', value: 'GB' },
      { col: 'risk_score', op: 'gt', value: 70 },
    ] });
    grid.sort.set([{ col: 'amount', dir: 'desc' }]);
  }
}

bootstrapApplication(AppComponent, {
  providers: [provideLattice({ createGrid })],
});

The grid holds a page, not a dataset

A client-side grid has to be given its rows before it can do anything with them, which is fine until the dataset is larger than a browser tab should ever hold. This screen never receives the dataset. Ten million transactions stay in the Parquet file; DuckDB reads it in the tab, and the grid receives the hundred rows it is about to paint. Scroll and it receives the next hundred. The readout under the statement is that arrangement in two numbers: how many rows match, and how many came back.

Click “Yesterday” and the numbers separate sharply: tens of thousands match, a hundred return, and DuckDB answers it by reading a small slice of the file, because the file is ordered by time and a one day window only touches the part that falls inside it. Nothing about the grid changed. The WHERE moved into the query, DuckDB counted the matches in the same statement that produced the page, and the ratio is the answer to “how much data would a client-side grid have had to move to do this”.

Not every question is answered from the same slice. Set the country to GB and the risk score above 70 and a similar number of rows match, but DuckDB reads about a quarter of the file to find them, far more than a time range costs, because neither column is the one this file happens to be ordered by. Same grid, same statement shape: what changes the cost is which columns the file’s own order can already narrow down.

Every interaction is one statement

The chips above the grid are ordinary filter trees, set with grid.filters.set(), which is exactly the call a header filter makes. Sorting a column is ORDER BY. Scrolling is LIMIT and OFFSET. Combining three chips is one WHERE with three conditions, not three passes. Each of those is a single statement, and the panel beside the grid prints the one DuckDB was actually given, with the values bound to it and the time it took in this browser.

Values are bound, never pasted in. A country arrives as a parameter, a date range arrives as a typed pair the engine casts for itself, and a list of statuses arrives as an IN list of parameters. That matters the moment the same code points at a real warehouse rather than a file in a tab.

Where the numbers come from

QUERY is the wall time of that statement, measured here, not a figure written into the page. RETURNED is the number of rows the grid was handed. DATASET is the row count of the file. The match count and the value of the matching set are both DuckDB’s own: the count rides along inside the rows statement, and the value is a sum the source pushes to the engine, so both describe everything that matches rather than the page that happens to be loaded.

How do I put a grid over a Parquet file or a warehouse?

Give duckdbAdapter a connection your page already made and a from clause, hand the adapter to createPushdownSource, and give the source to the grid. The grid then asks the source for a window of rows, the source turns the grid’s filter, sort and range into one statement, and the adapter runs it. Nothing about the columns, the filters or the rendering changes from a grid over an in-memory array. Point from at a table instead of read_parquet(...) and the same screen runs against your warehouse.

Lattice Grid Buy a licence

demo D296

Ten million transactions in Parquet in React

Ten million card transactions queried by DuckDB in the tab: every filter, sort and page becomes one statement, and only the hundred rows on screen come back

duckdbAdapter · createPushdownSource

Ten million card transactions sit in a Parquet file that never enters the grid. Every filter, sort and scroll becomes one statement DuckDB answers, and only the hundred rows on screen come back, with the statement, its bound values and its measured time printed beside them.

Building…
Loading a live grid…

This is the React version. The grid mounts through the createLatticeGrid adapter, which takes its configuration as ordinary props and hands back the live grid through a ref. The grid below is the same one every other tab runs.

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import * as LatticeGridCore from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.esm.min.js';
  import { createLatticeReact } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/react.esm.min.js';
  // DuckDB is your engine, not ours: the grid imports none of it. Swap this
  // import for a connection to your own warehouse and nothing below changes.
  import * as duckdb from 'https://cdn.jsdelivr.net/npm/@duckdb/duckdb-wasm/+esm';

  const { createGrid, duckdbAdapter, createPushdownSource } = LatticeGridCore;
  const { LatticeGrid } = createLatticeReact({ React, createGrid });

  const columns = [
    { field: 'ts', title: 'Time (UTC)', type: 'timestamp', typeOptions: { timeZone: 'UTC' } },
    { field: 'merchant', title: 'Merchant', filter: { type: 'set' } },
    { field: 'category', title: 'Category', filter: { type: 'set' } },
    { field: 'country', title: 'Country', filter: { type: 'set' } },
    { field: 'amount', title: 'Amount', type: 'number', format: { style: 'currency', currency: 'GBP' } },
    { field: 'status', title: 'Status', filter: { type: 'set' } },
    { field: 'risk_score', title: 'Risk', type: 'number' },
  ];

  function App() {
    const [source, setSource] = React.useState(null);

    React.useEffect(() => {
      let cancelled = false;
      (async () => {
        const bundle = await duckdb.selectBundle(duckdb.getJsDelivrBundles());
        const worker = await duckdb.createWorker(bundle.mainWorker);
        const db = new duckdb.AsyncDuckDB(new duckdb.ConsoleLogger(), worker);
        await db.instantiate(bundle.mainModule, bundle.pthreadWorker);
        const connection = await db.connect();

        // The engine resolves the URL, so give it an absolute one.
        const file = new URL('/demo-data/transactions-10m.parquet', location.origin).href;
        const adapter = duckdbAdapter({ connection, from: `read_parquet('${file}')` });

        // Windowed: the source turns the grid's filter, sort and scroll
        // position into one statement, and only the page on screen comes
        // back. The match count rides along inside that same statement.
        if (!cancelled) setSource(createPushdownSource({
          adapter, compute: LatticeGridCore, pageSize: 100,
          // sum and count are verified identical, so a total over the whole
          // matching set is computed by DuckDB rather than over the loaded page.
          aggregates: { default: 'engine-if-identical' },
        }));
      })();
      return () => { cancelled = true; };
    }, []);

    const onGridReady = (grid) => {
      // Any filter is an ordinary filter tree, and the adapter binds every
      // value rather than pasting it into the statement.
      grid.filters.set({ op: 'and', conditions: [
        { col: 'country', op: 'eq', value: 'GB' },
        { col: 'risk_score', op: 'gt', value: 70 },
      ] });
      grid.sort.set([{ col: 'amount', dir: 'desc' }]);
    };

    if (!source) return null;
    return (
      <LatticeGrid
        rowKey="transaction_id"
        toolPanel={{ side: 'left', panels: ['filters', 'columns'] }}
        columns={columns}
        source={source}
        onGridReady={onGridReady}
        style={{ height: '620px' }}
      />
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

The grid holds a page, not a dataset

A client-side grid has to be given its rows before it can do anything with them, which is fine until the dataset is larger than a browser tab should ever hold. This screen never receives the dataset. Ten million transactions stay in the Parquet file; DuckDB reads it in the tab, and the grid receives the hundred rows it is about to paint. Scroll and it receives the next hundred. The readout under the statement is that arrangement in two numbers: how many rows match, and how many came back.

Click “Yesterday” and the numbers separate sharply: tens of thousands match, a hundred return, and DuckDB answers it by reading a small slice of the file, because the file is ordered by time and a one day window only touches the part that falls inside it. Nothing about the grid changed. The WHERE moved into the query, DuckDB counted the matches in the same statement that produced the page, and the ratio is the answer to “how much data would a client-side grid have had to move to do this”.

Not every question is answered from the same slice. Set the country to GB and the risk score above 70 and a similar number of rows match, but DuckDB reads about a quarter of the file to find them, far more than a time range costs, because neither column is the one this file happens to be ordered by. Same grid, same statement shape: what changes the cost is which columns the file’s own order can already narrow down.

Every interaction is one statement

The chips above the grid are ordinary filter trees, set with grid.filters.set(), which is exactly the call a header filter makes. Sorting a column is ORDER BY. Scrolling is LIMIT and OFFSET. Combining three chips is one WHERE with three conditions, not three passes. Each of those is a single statement, and the panel beside the grid prints the one DuckDB was actually given, with the values bound to it and the time it took in this browser.

Values are bound, never pasted in. A country arrives as a parameter, a date range arrives as a typed pair the engine casts for itself, and a list of statuses arrives as an IN list of parameters. That matters the moment the same code points at a real warehouse rather than a file in a tab.

Where the numbers come from

QUERY is the wall time of that statement, measured here, not a figure written into the page. RETURNED is the number of rows the grid was handed. DATASET is the row count of the file. The match count and the value of the matching set are both DuckDB’s own: the count rides along inside the rows statement, and the value is a sum the source pushes to the engine, so both describe everything that matches rather than the page that happens to be loaded.

How do I put a grid over a Parquet file or a warehouse?

Give duckdbAdapter a connection your page already made and a from clause, hand the adapter to createPushdownSource, and give the source to the grid. The grid then asks the source for a window of rows, the source turns the grid’s filter, sort and range into one statement, and the adapter runs it. Nothing about the columns, the filters or the rendering changes from a grid over an in-memory array. Point from at a table instead of read_parquet(...) and the same screen runs against your warehouse.